VERSION 5.00
Begin VB.Form Measurement 
   Caption         =   "Measure 5315x Functions"
   ClientHeight    =   5445
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7350
   LinkTopic       =   "Form1"
   ScaleHeight     =   5445
   ScaleWidth      =   7350
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton EndProg 
      Caption         =   "End Program"
      Height          =   495
      Left            =   240
      TabIndex        =   6
      Top             =   4440
      Width           =   2895
   End
   Begin VB.ComboBox cboFunction 
      Height          =   315
      ItemData        =   "Measurements_5315x.frx":0000
      Left            =   240
      List            =   "Measurements_5315x.frx":0002
      TabIndex        =   5
      Text            =   "Select Measurement"
      ToolTipText     =   "Select the measurement you wish to make."
      Top             =   2040
      Width           =   2895
   End
   Begin VB.CommandButton TakeReadings 
      Caption         =   "Take Readings"
      Height          =   495
      Left            =   240
      TabIndex        =   4
      ToolTipText     =   "Press this to start a measurement."
      Top             =   3600
      Width           =   2895
   End
   Begin VB.ListBox List1 
      Height          =   3180
      Left            =   3600
      TabIndex        =   3
      ToolTipText     =   "The data will be printed in this window."
      Top             =   1920
      Width           =   3615
   End
   Begin VB.CommandButton SelectIO 
      Caption         =   "Select I/O"
      Height          =   495
      Left            =   4200
      TabIndex        =   1
      ToolTipText     =   "Press to attempt connection to Instrument"
      Top             =   840
      Width           =   2535
   End
   Begin VB.TextBox ioAddr 
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Text            =   "GPIB0::22"
      ToolTipText     =   "Enter device address (GPIB0::22) and then press Select I/O button."
      Top             =   840
      Width           =   2295
   End
   Begin VB.Label MeasFunc 
      Caption         =   "Desired Measurement Function"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   1680
      Width           =   2655
   End
   Begin VB.Label Label1 
      Caption         =   "Enter Instrument Address (e.g. GPIB0::22), then press Select I/O button to connect"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   240
      TabIndex        =   2
      Top             =   240
      Width           =   4215
   End
End
Attribute VB_Name = "Measurement"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
' This programming example controls a 5315x series counter and allows measurements of Frequency and Power.
'
' The program uses VISA for IO communication.  It uses the module visa32.bas that is supplied by the
' IVI foundation to provide the import library prototypes for VISA.  If using Agilent Visa, this file
' can be found at directory:
'
' C:\Program Files\IVI Foundation\Visa\WinNT\agvisa\include
'
' On some other Visa Vendor's system, it may also exist directory:
'
' C:\Program Files\IVI Foundation\Visa\WinNT\Include
'
'
'
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
' Copyright  2010 Agilent Technologies Inc. All rights reserved.
'
' You have a royalty-free right to use, modify, reproduce and distribute this
' example files (and/or any modified version) in any way you find useful, provided
' that you agree that Agilent has no warranty, obligations or liability for any
' Sample Application Files.
'
' Agilent Technologies will not modify the program to provide added
' functionality or construct procedures to meet your specific needs.
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

Option Explicit

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Dim videfaultRM As Long     ' Resource manager session returned by viOpenDefaultRM(videfaultRM)
Dim vi As Long              ' Session identifier of devices
Dim errorStatus As Long     ' VISA function status return code

Dim connected As Boolean    ' Sets flag to determine if instrument is connected or not
Dim addr As String          ' Used for the instrument address
Dim addrtype As String      ' Used for the I/O type

Dim ReturnedData As String  ' Used to read returned data


Function OpenPort() As Boolean
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
' This function opens a port (the communication between the instrument and computer).
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

Dim addr As String

' If port is open, close it
If connected Then
    errorStatus = viClose(vi)
End If

' Get I/O Address
addr = UCase(ioAddr.Text)

If InStr(addr, "GPIB") Then
    ' Open default resource manager
    errorStatus = viOpenDefaultRM(videfaultRM)
    
    ' If an error occurs here, not sure what is going on
    If errorStatus < VI_SUCCESS Then
        MsgBox "Unexpected error trying to open Default Resource Manager"
        connected = False
        OpenPort = False
        Exit Function
    End If
Else
    MsgBox "Only GPIB Interface is supported"
    connected = False
    OpenPort = False
    Exit Function
End If

If Not (InStr(addr, "::INSTR")) Then
    ' need to add ::INSTR to address
    addr = addr & "::INSTR"
End If

' Open communication to the instrument
errorStatus = viOpen(videfaultRM, addr, 0, 0, vi)
If errorStatus < VI_SUCCESS Then
    MsgBox "Failed opening address: " & addr
    connected = False
    OpenPort = False
    Exit Function
End If

' Set timeout in milliseconds; set the timeout for your requirements
errorStatus = viSetAttribute(vi, VI_ATTR_TMO_VALUE, 10000)
    
' Should not happen, but better safe than sorry
If errorStatus < VI_SUCCESS Then
    MsgBox "Failed setting time out value"
    ioAddr.Text = "GPIB0::9"
    ioAddr.Refresh
    connected = False
    OpenPort = False
    Exit Function
End If

' Check and make sure the correct instrument is addressed
SendCmd "*IDN?"
ReturnedData = GetData()

If ((InStr(ReturnedData, "53150A") = 0) And (InStr(ReturnedData, "53151A") = 0) And (InStr(ReturnedData, "53152A") = 0)) Then
    MsgBox "Incorrect instrument; expected 53150,53151,or 53152; got: " & ReturnedData
    ioAddr.Text = "GPIB0::22"
    ioAddr.Refresh
    connected = False
    OpenPort = False
    
    ' Close instrument session
    errorStatus = viClose(vi)

    ' Close the session
    errorStatus = viClose(videfaultRM)

    Exit Function
End If

' Clear list box
List1.Clear

List1.AddItem "Instrument ID is:"
List1.AddItem ReturnedData

connected = True
OpenPort = True

If OpenPort Then
' Enable other buttons
Measurement.cboFunction.Enabled = True
Measurement.TakeReadings.Enabled = True
Else
' Enable other buttons
Measurement.cboFunction.Enabled = False
Measurement.TakeReadings.Enabled = False
End If

End Function

Sub RunProgram()
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
' This program sets the 34970A to a pre-defined state, makes measurements, and
' returns the measurements.
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

' Call the function that opens communication with instrument
If connected = False Then
    If Not OpenPort Then
        Exit Sub
    End If
End If

' Abort a scan, if one is in progress
SendCmd "ABORt"

' Call sub to setup the 5315xA
Setup

List1.Clear
List1.AddItem "Setting up instrument"
List1.Refresh

' Call sub to trigger the counter, make measurements, and return the readings
Readings

' Enable Exit button
Exit_Prog.SetFocus

End Sub

Private Sub Setup()
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
' This sub performs the instrument setup.
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

Dim ii As Integer
'Dim TrigTime As Double
Dim Units As String
Dim stupid As Integer

stupid = 0

Units = " Hz"    ' 67% chance it will be Hz so init to that

List1.Clear
List1.AddItem "   "    ' Insert a blank line

' Reset instrument to turn-on condition
SendCmd "*RST"

' Configure selected measurement
If (cboFunction.ListIndex = 0) Then
    ' is Frequency 1
    SendCmd "CONF:FREQ DEF,DEF,(@1)"
    List1.AddItem "Reading #    Frequency Chan. 1"
ElseIf (cboFunction.ListIndex = 1) Then
    ' is Frequency 2
    SendCmd "CONF:FREQ DEF,DEF,(@2)"
    List1.AddItem "Reading #    Frequency Chan. 2"
ElseIf (cboFunction.ListIndex = 2) Then
    ' is Power
    SendCmd "CONF:POW DEF, DEF"    ' Chan is optional in syntax -- can only be channel 2, so no need to send
    List1.AddItem "Reading #    Power Chan. 2"
    Units = " dBm"

Else
    ' do error here
    MsgBox "Please select a valid measurement function."
    Exit Sub
End If

For ii = 1 To 5
    ' Wait for instrument to finish the configures above
    SendCmd "*OPC?"
    ReturnedData = GetData()
    SendCmd "INIT"            ' Trigger the measurement, ensures a new reading each time
    SendCmd "FETCH?"
    ReturnedData = GetData()
    List1.AddItem "      " + CStr(ii) + "              " + ReturnedData + Units
    List1.Refresh

Next

 'Check for errors
Call Check_Error("Setup")

'  ***********  ALTERNATE METHOD USING CONTINUOUS TRIGGERING ***************************
' Below is an alternate way to get multiple readings by having the counter continuously trigger itself
' and take a single reading each time.  NOTE:  You must delay after the FETCH? long enough
' to be certain the same reading is not returned multiple times.  The delay will be frequency dependent --
' that is to say, very low frequencies may need some delay, while high frequencies may not need any.

' Wait for instrument to finish setting up from CONFIG
'SendCmd "*OPC?"
'ReturnedData = GetData()


'SendCmd "INIT:CONT ON"    ' turn on continuous init

'For ii = 1 To 5
'    SendCmd "FETCH?"
'    ReturnedData = GetData()
'Next

End Sub

Private Sub SendCmd(SCPICmd As String)
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
' This routine will send a SCPI command string to the instrument. If the
' command contains a question mark (i.e., is a query command), you must
' read the response with the 'GetData' function.
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

Dim commandstr As String     ' Command passed to instrument
Dim actual As Long           ' Number of characters sent/returned

' Set up an error handler within subroutine to be called if an error occurs.
On Error GoTo VIerrorHandler

' Write the command to the instrument (terminated by a linefeed)
commandstr = SCPICmd & Chr$(10)
errorStatus = viWrite(vi, ByVal commandstr, Len(commandstr), actual)

Exit Sub
    
VIerrorHandler:

' Display the error message
MsgBox " I/O Error"

' Close the device session
errorStatus = viClose(vi)

' Close the session
errorStatus = viClose(videfaultRM)

End

End Sub

Function GetData() As String
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
' This function reads the string returned by the instrument
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
    
Dim readbuf As String * 2048   ' Buffer used for returned string
Dim replyString As String      ' Store the string returned
Dim valpos As Integer          ' Location of any null's and line feed in readbuf
Dim actual As Long             ' Number of characters sent/returned

' Read the response string
errorStatus = viRead(vi, ByVal readbuf, 2048, actual)
replyString = readbuf

If actual = 0 Then
    GoTo VIerrorHandler
End If

' Strip out the line feed, if any
If InStr(replyString, Chr$(10)) Then
    replyString = Left(replyString, InStr(replyString, Chr$(10)) - 1)
End If

' Strip out the carriage returnfeed, if any
If InStr(replyString, Chr$(13)) Then
    replyString = Left(replyString, InStr(replyString, Chr$(13)) - 1)
End If

' return data
GetData = replyString

Exit Function

VIerrorHandler:

' Display the error message
MsgBox " I/O Error in GetData()"

' Close the device session
errorStatus = viClose(vi)

' Close the session
errorStatus = viClose(videfaultRM)

End

End Function

Sub Check_Error(msg As String)
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
' Checks for syntax and other errors.
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

Dim err_code As Integer
Dim err_msg As String
Dim TempCheck As Integer
Dim valpos As Integer

' check for initial error
SendCmd "SYSTem:ERRor?"
err_msg = GetData()
      
' If error found, check for more errors and exit program
err_code = Val(err_msg)

TempCheck = 0
While err_code <> 0
    TempCheck = 1
    
    msg = "Error in: " + msg + Chr$(10)
    msg = msg + "Error Number: " + Str$(err_code) + Chr$(10) + "Error Message: " + err_msg
    
    MsgBox msg
    
    ' check for more errors
    SendCmd "SYSTem:ERRor?"
    err_msg = GetData()
    err_code = Val(err_msg)
Wend

If TempCheck <> 0 Then
    
    ' Send a device clear
    SendCmd "*CLS"
    
    ' Close instrument session
    errorStatus = viClose(vi)
    
    ' Close the session
    errorStatus = viClose(videfaultRM)
    
    ' end the program
    End
End If

End Sub

Private Sub GetReadings_Click()
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
' Call sub routine to trigger instrument and get readings.
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

' Call the Readings sub
RunProgram

End Sub

Private Sub Exit_Prog_Click()
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
' Calls sub to close the session and end program.
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

' Calls the sub
End_Prog

End Sub

Sub End_Prog()
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
' Closes the session and program.
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

If connected Then
    ' Abort a scan
    SendCmd "ABORt"
    
    ' Send a device clear
    SendCmd "*CLS"
    
    ' Close instrument session
    errorStatus = viClose(vi)
    
    ' Close the session
    errorStatus = viClose(videfaultRM)
End If

End

End Sub


Private Sub Command1_Click()
Setup
End Sub

Private Sub EndProg_Click()
    
    ' close the IO session if one is open
    If connected Then
        errorStatus = viClose(vi)
    End If
    
    'End and exit the program
    Unload Me
    
    End

End Sub

Private Sub Form_Load()

    cboFunction.Clear
    cboFunction.AddItem "Channel 1 Frequency"
    
    cboFunction.AddItem "Channel 2 Frequency"
    
    cboFunction.AddItem "Channel 2 Power"
    
    ' Disable measurements until IO connected
    'Measurement.cboFunction.Enabled = False
    Measurement.TakeReadings.Enabled = False

End Sub

Private Sub SelectIO_Click()
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
' Clicking this button causes IO session to be initiated
'"""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""

' Open the interface
OpenPort
   
End Sub

Private Sub Text2_Change()

End Sub

Private Sub TakeReadings_Click()
' Configure and take readings
Setup

End Sub
